<?php
require_once (PATH_CONTROLLERS . "Common.php") ;
require_once (PATH_MODELS . "hr/DepartmentClass.php") ;
require_once (PATH_MODELS . "hr/DepartmentInterPermissionClass.php") ;

class Department extends ControllerBase {
	private $type = "" ;
	function __construct() {
		$this->db = $_SESSION[SE_DB] ;
	}
	function __destruct() {
		unset($this->db) ;
	}
	public function processRequest($params) {
		$this->type = REQ_VIEW ;
		
		try {
			$this->db->open() ;
			if (isset($params) && count($params) > 0) {
				if (isset($params['type']))
					$this->type = $params['type'] ;
			}
			switch ($this->type) {
				case REQ_ADD:
					$this->addRecord($params) ;
					break ;
				case REQ_UPDATE:
					$this->updateRecord($params) ;
					break ;
				case REQ_DELETE:
					$this->deleteRecord($params) ;
					break ;
				case REQ_GET:
					$this->getRecord($params) ;
					break ;
				case REQ_LIST:
					$this->getList($params) ;
					break ;
				case REQ_REPORT:
					$this->getReport($params) ;
					break ;
				case REQ_VIEW:
					$this->getView() ;
					break ;
				default:
					$this->sendJsonResponse(Status::Error,"invalid request.","",$this->type) ;
					break ;
			}
			$this->db->close() ;
			return true ;
		} catch (Exception $e) {
			$this->db->close() ;
			die ($e->getMessage()) ;
		}
	}
	private function addRecord($params) {
		$cls = new DepartmentClass($this->db) ;
		$datas = array() ;
		$orgid = $_SESSION[SE_ORGID] ;
		$modifyby = $_SESSION[SE_USERID] ;
		$modifydate = date_create('now')->format('Y-m-d H:i:s') ;
		$ws = $_SESSION[SE_REMOTE_IP] ;
		
		$datas[] = $this->db->fieldValue(DepartmentTable::C_DESC,$this->getParam($params,'desc',"")) ;
		$datas[] = $this->db->fieldValue(DepartmentTable::C_REF,$this->getParam($params,'refno',"")) ;
		$datas[] = $this->db->fieldValue(DepartmentTable::C_WS_ID,$ws) ;
		$datas[] = $this->db->fieldValue(DepartmentTable::C_MODIFY_BY,$modifyby) ;
		$datas[] = $this->db->fieldValue(DepartmentTable::C_CREATE_BY,$modifyby) ;
		$datas[] = $this->db->fieldValue(DepartmentTable::C_MODIFY_DATE,$modifydate) ;
		$datas[] = $this->db->fieldValue(DepartmentTable::C_CREATE_DATE,$modifydate) ;
		$datas[] = $this->db->fieldValue(DepartmentTable::C_ORG_ID,$orgid) ;
		
        $interPermissions = $this->getParam($params, 'inter_permission', '');
        
		try {
			$id = $cls->addRecord($datas) ;
			if ($id > 0) {
                $this->addInterPermission($id, $interPermissions);
				$this->sendJsonResponse(Status::Ok,"Department successfully added to the system.",$id,$this->type);
			} else {
				$this->sendJsonResponse(Status::Error,"Sorry, there is a error in adding new department to the system.",$id, $this->type) ;
			}
		} catch (Exception $e) {
			Log::write('[Department]' . $e->getMessage());
			$this->sendJsonResponse(Status::Error,"Sorry, there is a error in database operation.","",$this->type) ;
		}
		unset($cls) ;
	}
	private function updateRecord($params) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new DepartmentClass($this->db) ;
            $clsInter = new DepartmentInterPermissionClass($this->db);
			try {
				$datas = array() ;
				$modifyby = $_SESSION[SE_USERID] ;
				$modifydate = date_create('now')->format('Y-m-d H:i:s') ;
				$ws = $_SESSION[SE_REMOTE_IP] ;

				$datas[] = $this->db->fieldValue(DepartmentTable::C_DESC,$this->getParam($params,'desc',"")) ;
				$datas[] = $this->db->fieldValue(DepartmentTable::C_REF,$this->getParam($params,'refno',"")) ;
				$datas[] = $this->db->fieldValue(DepartmentTable::C_WS_ID,$ws) ;
				$datas[] = $this->db->fieldValue(DepartmentTable::C_MODIFY_BY,$modifyby) ;
				$datas[] = $this->db->fieldValue(DepartmentTable::C_MODIFY_DATE,$modifydate) ;
                $interPermissions = $this->getParam($params, 'inter_permission', '');
                
				$cls->updateRecord($id,$datas) ;
                
                $clsInter->deleteRecord($id);
                $this->addInterPermission($id, $interPermissions);
                
				$this->sendJsonResponse(Status::Ok,"Department detail successfully updated to the system.",$id,$this->type) ;
			} catch (Exception $e) {
				Log::write('[Department]' . $e->getMessage());
				$this->sendJsonResponse(Status::Error,"Sorry, there is a error in updating department detail to the system.","",$this->type) ;
			}
			unset($cls) ;
            unset($clsInter);
		}else {
			$this->sendJsonResponse(Status::Error,"You must supply the department id you wish to update. Please try again.","",$this->type);
		}
	}
	private function deleteRecord($params) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new DepartmentClass($this->db) ;
            $clsInter = new DepartmentInterPermissionClass($this->db);
			try {
				$cls->deleteRecord($id) ; 
                $clsInter->deleteRecord($id);
				$this->sendJsonResponse(Status::Ok,"Department successfully deleted from the system.","",$this->type);
			} catch (Exception $e) {
				Log::write('[Department]' . $e->getMessage());
				$this->sendJsonResponse(Status::Error,"Sorry, there is a problem in deleting department record from the system.","",$this->type) ;
			}
			unset($cls) ;
            unset($clsInter);
		} else {
			$this->sendJsonResponse(Status::Error,"You must supply the department id you wish to delete. Please try again.","",$this->type);
		}
	}
	private function getList($conditions=null) {
		// $cls = new DepartmentClass($this->db) ;
		// $filter = $this->db->fieldParam(DepartmentTable::C_ORG_ID) ;
		// $params = array() ;
		// $params[] = $this->db->valueParam(DepartmentTable::C_ORG_ID,$_SESSION[SE_ORGID]) ;
		// $rows = $cls->getTable($filter,DepartmentTable::C_DESC,$params) ;
		// $list = "" ;
		// foreach ($rows as $row) {
		// 	$id = $row[DepartmentTable::C_ID] ;
		// 	$list .= "<tr>" ;
		// 	$list .= "<td>" . $id . "</td>" ;
		// 	$list .= "<td>" . $row[DepartmentTable::C_DESC] . "</td>" ;
		// 	$list .= "<td>" . $row[DepartmentTable::C_REF] . "</td>" ;
		// 	$list .= "<td style='text-align:center'><a href='javascript:' onclick='editDept(" . $id . ",this)'><img src='image/edit_16.png' title='Edit'></img></a></td>" ;
		// 	$list .= "<td style='text-align:center'><a href='javascript:' onclick='deleteDept(" . $id . ",this)'><img src='image/delete_16.png' title='Delete'></img></a></td>" ;
		// 	$list .= "</tr>" ;
		// }
		// unset($rows) ;
		// unset($cls) ;
		// return $list ;

		//=======================================================

		$cls = new DepartmentClass($this->db) ;

		$filter = $this->db->fieldParam(DepartmentTable::C_ORG_ID) ;
		$params = array() ;
		$params[] = $this->db->valueParam(DepartmentTable::C_ORG_ID,$_SESSION[SE_ORGID]) ;
		$rows = $cls->getTable($filter,DepartmentTable::C_DESC,$params) ;
		$arrList = [];
		foreach ($rows as $i => $row) {
			$arrList[$i]["id"] = $row[DepartmentTable::C_ID];
			$arrList[$i]["desc"] = $row[DepartmentTable::C_DESC];	
			$arrList[$i]["ref"] = $row[DepartmentTable::C_REF];	
			$arrList[$i]["actions"] = '<a onclick="javascript:editDept('. $row[DepartmentTable::C_ID] .',this);" class="btn btn-sm btn-clean btn-icon btn-icon-md" title="Edit details">
									  	<i class="fa fa-edit"></i>
									  </a>
									  <a onclick="javascript:deleteDept('. $row[DepartmentTable::C_ID] .',this);" class="btn btn-sm btn-clean btn-icon btn-icon-md" title="Delete">
									  	<i class="fa fa-trash"></i>
									  </a>';	
		}

		$this->sendJsonResponse(Status::Ok,"",$arrList,$this->type);
		
		unset($rows) ;
		unset($cls) ;
	}
	private function getRecord($params=null) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new DepartmentClass($this->db) ;
			$row = $cls->getRecord($id) ;
			if (is_null($row)) {
				$this->sendJsonResponse(Status::Error,"Invalid department id. Please try again.",$id,$this->type);
			} else {
				$datas = array() ;
				$datas['id'] = $id ;
				$datas['desc'] = $row[DepartmentTable::C_DESC];
				$datas['refno'] = $row[DepartmentTable::C_REF] ;
                $datas['inter_permission'] = $this->getInterPermission($id);
				$this->sendJsonResponse(Status::Ok,"",$datas,$this->type) ;
			}
			unset($cls) ;
		} else {
			$this->sendJsonResponse(Status::Error,"Missing department id. Please try again.","",$this->type);
		}
	}
	private function getView() {
		ob_start() ;
		include (PATH_VIEWS . "hr/DepartmentView.php") ;
		echo Util::minifyHtml(ob_get_clean()) ;
	}
	private function getReport($params=null) {
		require_once(PATH_LIB . 'ListPdf.php');
		
		$cls = new DepartmentClass($this->db) ;
		$filter = $this->db->fieldParam(DepartmentTable::C_ORG_ID) ;
		$params = array() ;
		$params[] = $this->db->valueParam(DepartmentTable::C_ORG_ID,$_SESSION[SE_ORGID]) ;
		$rows = $cls->getTable($filter,DepartmentTable::C_DESC,$params) ;

		$i = 'items';
		$nr = 'newrow';
		$datas = array() ;
		foreach ($rows as $row) {
			$items = array() ;
			$items[$i][] = $this->createPdfItem($row[DepartmentTable::C_ID],30) ;
			$items[$i][] = $this->createPdfItem($row[DepartmentTable::C_DESC],200) ;
			$items[$i][] = $this->createPdfItem($row[DepartmentTable::C_REF],100) ;
			$items[$nr] = "1";
			$datas[] = $items ;
		}
		$cols = array() ;
		$cols[] = $this->createPdfItem("ID",30,0,"C","B");
		$cols[] = $this->createPdfItem("Description",200,0,"C","B") ;
		$cols[] = $this->createPdfItem("Ref",100,0,"C","B") ;
		$pdf = new ListPdf('P');
		$pdf->setCompanyName($_SESSION[SE_ORGNAME]) ;
		$pdf->setReportTitle("Department Listing") ;
		$pdf->setColumnsHeader($cols) ;
		$pdf->render($datas) ;
		$pdf->Output('department.pdf', 'I');
		unset($rows) ;
		unset($cls) ;
		unset($datas) ;
		unset($params) ;
		unset($items) ;
		unset($cols) ;
	}
    private function getInterPermission($deptId){
		$cls = new DepartmentInterPermissionClass($this->db) ;
        $clsDept = new DepartmentClass($this->db);
		$rows = $cls->getInterPermission($deptId) ;
		$lines = "" ;
		if (!is_null($rows) || count($rows) > 0) {
			foreach ($rows as $row) {
                if (strlen($lines) > 0){
					$lines .= "|" ;
                }
				$lines .= $row[DepartmentInterPermissionTable::C_INTER];
                $lines .= "~";
                $lines .= $row[DepartmentTable::C_DESC];
			}							
        }
		unset($cls) ;
        unset($clsDept);
		return $lines ;
    }
    private function addInterPermission($deptId, $interPermissions){
		$cls = new DepartmentInterPermissionClass($this->db) ;
		if ($interPermissions != "") {
			$lines = explode("|",$interPermissions) ;
			for ($i= 0;$i < count($lines) ;$i++) {
                
                $cls->deleteInterPermission($deptId, $lines[$i]);
                
                $datas = array() ;
                $datas[] = $this->db->fieldValue(DepartmentInterPermissionTable::C_ID,$deptId);
                $datas[] = $this->db->fieldValue(DepartmentInterPermissionTable::C_INTER,$lines[$i]) ;
                
                $cls->addRecord($datas) ;
			}
		}
		unset($cls) ;
    }
    
    private function getDeptOption(){
		$vls = $this->getValueList(DepartmentTable::C_TABLE, DepartmentTable::C_ID, DepartmentTable::C_DESC,array('code'=>'0','desc'=>'--- Select a Department ---')) ;
		return Util::createOptionValue($vls) ;
    }
}
?>